]> ruderich.org/simon Gitweb - config/dotfiles.git/blobdiff - setup.sh
setup.sh: Fix typo in urxvt 256-color check.
[config/dotfiles.git] / setup.sh
index 51074e244875d53305688e700662d003c6f9e30d..39f706efe21fe016fbc3f5cfd5bbe5d92d60a424 100755 (executable)
--- a/setup.sh
+++ b/setup.sh
 
 . ../lib.sh
 
-hostname=`hostname`
+# Helper functions.
+terminal_info() {
+    infocmp "$@" 2>&1
+}
+terminal_available() {
+    terminal_info "$@" > /dev/null
+}
+# Check if `infocmp` is available.
+if ! infocmp > /dev/null 2>&1; then
+    echo 'Warning: `infocmp` not available! 256color checks will fail.'
+    echo
+fi
+
+
+# Create private temporary directory used by many tools (including GNU screen
+# and tmux).
+mkdir -p ~/.tmp
+chmod 0700 ~/.tmp
 
 # Generate ~/.less with lesskey.
 lesskey lesskey
 chmod 0600 ~/.less
 
-# As screen-256color is not widely supported use it only on machines known to
-# work.
+# Find the required options to get colored ls output. GNU ls is preferred. See
+# shell/aliases.in for details. Doing this here instead of in shell/aliases
+# speeds up shell starts.
+#
+# Check if colors are available.
+ls --color > /dev/null 2>&1
+if test $? -eq 0; then
+    ls_color=gnu
+else
+    ls -G > /dev/null 2>&1
+    if test $? -eq 0; then
+        ls_color=cli
+    else
+        ls_color=
+    fi
+fi
+# Absolute path to `ls`.
+ls_path=`which ls`
+# GNU ls with colors.
+if test "x$ls_color" = xgnu; then
+    ls_env=
+    ls_color='--color'
+# Normal (BSD) ls with colors.
+elif test "x$ls_color" = xcli; then
+    ls_env='CLICOLOR_FORCE=1'
+    ls_color='-G'
+# Simple ls with no colors.
+else
+    ls_env=
+    ls_color=
+fi
+generate perl shell/aliases \
+    -e 'while (<STDIN>) {
+            s/\bLS_ENV\b/$ARGV[0]/;
+            s/\bLS_PATH\b/$ARGV[1]/;
+            s/\bLS_COLOR\b/$ARGV[2]/;
+            print;
+        }' \
+    "$ls_env" "$ls_path" "$ls_color"
+
 generate cat screenrc .in
-if [ $hostname != asp -a $hostname != systemofadown ]; then
+# As screen-256color is not widely supported use it only on machines where the
+# matching terminfo entry is available. This also requires a terminal emulator
+# which supports 256 colors. Also used for tmux.
+use_256colors=
+if terminal_available screen-256color; then
+    # Called through SSH connection, assume the local system supports 256
+    # colors.
+    if test -n "$SSH_CONNECTION"; then
+        use_256colors=1
+    # We have rxvt-unicode installed, check if it supports 256 colors.
+    elif installed urxvt; then
+        # Thanks to deryni in #rxvt-unicode on Freenode (2012-10-14 22:54
+        # CEST) for the strings/grep idea. The grep check is for "correct" 256
+        # rxvt-unicode binaries (e.g. Debian's rxvt-unicode-256color), the
+        # terminal_info check for manual installations which modify
+        # rxvt-unicode's terminfo entry.
+        urxvt_path=`which urxvt`
+        urxvt_grep=`strings "$urxvt_path" | grep '^TERM=rxvt-'`
+        if test x"$urxvt_grep" = 'xTERM=rxvt-unicode-256color' \
+                || terminal_info rxvt-unicode \
+                    | grep -F 'colors#256' >/dev/null; then
+            use_256colors=1
+        fi
+    # Check if XTerm supports 256 colors (not a perfect check, but most XTerm
+    # support 256 colors).
+    elif terminal_available xterm-256color; then
+        use_256colors=1
+    fi
+fi
+if test -z "$use_256colors"; then
+    echo screenrc: removing 256 colors
     sed 's/Enable 256 color/Disable 256 color/;
          s/screen-256color/screen/' screenrc > screenrc.tmp
     mv screenrc.tmp screenrc
 fi
 # Some options are only necessary when running as root. They are marked as
 # "(ROOT)".
-if [ x`id -u` != x0 ]; then
+if test "`id -u`" -ne 0; then
     echo screenrc: removing root options
     grep -v '(ROOT)' screenrc > screenrc.tmp
     mv screenrc.tmp screenrc
 fi
-# I use some features of screen which are only in Git. Drop them on machines
-# which have older versions. They are marked as "(GIT)".
-if [ $hostname != asp -o x`id -u` = x0 ]; then
+# I use some features of GNU screen which are only in Git or very recent GNU
+# screen versions. Drop them on machines which have older versions. They are
+# marked as "(GIT)".
+if test ! -d "$HOME/development/shell/screen"; then
     echo screenrc: removing Git features
     grep -v '(GIT)' screenrc > screenrc.tmp
     mv screenrc.tmp screenrc
@@ -57,12 +143,33 @@ if installed rxvt; then
 fi
 # Display current battery charge on computers with a battery. Necessary lines
 # are marked as "(BATTERY)".
-if [ ! -d /sys/class/power_supply/BAT0 ]; then
+if test ! -d /sys/class/power_supply/BAT0; then
     echo screenrc: removing battery display
     grep -v '(BATTERY)' screenrc > screenrc.tmp
     mv screenrc.tmp screenrc
 fi
 
+if installed tmux; then
+    generate perl tmux.conf ./bin/remove-continuation.pl
+
+    # 256 colors not available.
+    if test -z "$use_256colors"; then
+        echo tmux.conf: removing 256 colors
+        sed 's/Enable 256 color/Disable 256 color/;
+             s/screen-256color/screen/' tmux.conf > tmux.conf.tmp
+        mv tmux.conf.tmp tmux.conf
+    fi
+    # Tmux doesn't display a warning if the shell wasn't found!
+    if test ! -x '/bin/zsh'; then
+        echo tmux.conf: removing /bin/zsh as shell
+        sed 's/zsh/sh/' tmux.conf > tmux.conf.tmp
+        mv tmux.conf.tmp tmux.conf
+    fi
+fi
+
+# Htop overwrites the comments in its configuration file.
+generate cat htoprc .in
+
 # Link setup for shells.
 link shell ~/.shell
 link bash ~/.bash
@@ -87,6 +194,9 @@ link screenrc ~/.screenrc
 if installed tmux; then
     link tmux.conf ~/.tmux.conf
 fi
+if installed htop; then
+    link htoprc ~/.htoprc
+fi
 
 # Create rlwrap history directory.
 mkdir -p shell/rlwrap